Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/Manager/HeartbeatManager.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/Manager/HeartbeatManager.cs	(revision 6463)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/Manager/HeartbeatManager.cs	(revision 6463)
@@ -0,0 +1,148 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Services.Hive.Common;
+using HeuristicLab.Services.Hive.Common.DataTransfer;
+
+namespace HeuristicLab.Services.Hive {
+  public class HeartbeatManager {
+    private DataAccess.IHiveDao dao {
+      get { return ServiceLocator.Instance.HiveDao; }
+    }
+    private IAuthorizationManager auth {
+      get { return ServiceLocator.Instance.AuthorizationManager; }
+    }
+
+    /// <summary>
+    /// This method will be called every time a slave sends a heartbeat (-> very often; concurrency is important!)
+    /// </summary>
+    /// <returns>a list of actions the slave should do</returns>
+    public List<MessageContainer> ProcessHeartbeat(Heartbeat heartbeat) {
+      List<MessageContainer> actions = new List<MessageContainer>();
+      Slave slave = dao.GetSlave(heartbeat.SlaveId);
+      if (slave == null) {
+        actions.Add(new MessageContainer(MessageContainer.MessageType.SayHello));
+      } else {
+        // update slave data
+        slave.FreeCores = heartbeat.FreeCores;
+        slave.FreeMemory = heartbeat.FreeMemory;
+        slave.CpuUtilization = heartbeat.CpuUtilization;
+        slave.IsAllowedToCalculate = SlaveIsAllowedToCalculate(slave.Id);
+        slave.SlaveState = (heartbeat.JobProgress != null && heartbeat.JobProgress.Count > 0) ? SlaveState.Calculating : SlaveState.Idle;
+        slave.LastHeartbeat = DateTime.Now;
+        dao.UpdateSlave(slave);
+
+        // update job data
+        actions.AddRange(UpdateJobs(heartbeat, slave.IsAllowedToCalculate));
+
+        // assign new job
+        if (heartbeat.AssignJob && slave.IsAllowedToCalculate && heartbeat.FreeCores > 0) {
+          var availableJobs = dao.GetWaitingJobs(slave, 1);
+          if (availableJobs.Count() > 0) {
+            var job = availableJobs.First();
+            if (AssignJob(slave, job))
+              actions.Add(new MessageContainer(MessageContainer.MessageType.CalculateJob, job.Id));
+          }
+        }
+      }
+      return actions;
+    }
+
+    // returns true if assignment was successful
+    private bool AssignJob(Slave slave, Job job) {
+      // load job again and check if it is still available (this is an attempt to reduce the race condition which causes multiple heartbeats to get the same job assigned)
+      if (dao.GetJob(job.Id).State != JobState.Waiting) return false;
+
+      job = dao.UpdateJobState(job.Id, JobState.Transferring, slave.Id, null, null);
+
+      // from now on the job has some time to send the next heartbeat (ApplicationConstants.TransferringJobHeartbeatTimeout)
+      job.LastHeartbeat = DateTime.Now;
+      dao.UpdateJob(job);
+      return true;
+    }
+
+    /// <summary>
+    /// Update the progress of each job
+    /// Checks if all the jobs sent by heartbeat are supposed to be calculated by this slave
+    /// </summary>
+    private IEnumerable<MessageContainer> UpdateJobs(Heartbeat heartbeat, bool IsAllowedToCalculate) {
+      List<MessageContainer> actions = new List<MessageContainer>();
+
+      if (heartbeat.JobProgress == null)
+        return actions;
+
+      if (!IsAllowedToCalculate) {
+        actions.Add(new MessageContainer(MessageContainer.MessageType.PauseAll));
+      } else {
+        // process the jobProgresses
+        foreach (var jobProgress in heartbeat.JobProgress) {
+          Job curJob = dao.GetJob(jobProgress.Key);
+          if (curJob == null) {
+            // job does not exist in db
+            actions.Add(new MessageContainer(MessageContainer.MessageType.AbortJob, jobProgress.Key));
+            LogFactory.GetLogger(this.GetType().Namespace).Log("Job does not exist in DB: " + jobProgress.Key);
+          } else {
+            if (curJob.CurrentStateLog.SlaveId == Guid.Empty || curJob.CurrentStateLog.SlaveId != heartbeat.SlaveId) {
+              // assigned slave does not match heartbeat
+              actions.Add(new MessageContainer(MessageContainer.MessageType.AbortJob, curJob.Id));
+              LogFactory.GetLogger(this.GetType().Namespace).Log("The slave " + heartbeat.SlaveId + " is not supposed to calculate Job: " + curJob);
+            } else if (!JobIsAllowedToBeCalculatedBySlave(heartbeat.SlaveId, curJob)) {
+              // assigned resources ids of job do not match with slaveId (and parent resourceGroupIds); this might happen when slave is moved to different group
+              actions.Add(new MessageContainer(MessageContainer.MessageType.PauseJob, curJob.Id));
+            } else {
+              // save job execution time
+              curJob.ExecutionTime = jobProgress.Value;
+              curJob.LastHeartbeat = DateTime.Now;
+
+              switch (curJob.Command) {
+                case Command.Stop:
+                  actions.Add(new MessageContainer(MessageContainer.MessageType.StopJob, curJob.Id));
+                  break;
+                case Command.Pause:
+                  actions.Add(new MessageContainer(MessageContainer.MessageType.PauseJob, curJob.Id));
+                  break;
+                case Command.Abort:
+                  actions.Add(new MessageContainer(MessageContainer.MessageType.AbortJob, curJob.Id));
+                  break;
+              }
+              dao.UpdateJob(curJob);
+            }
+          }
+        }
+      }
+      return actions;
+    }
+
+    private bool JobIsAllowedToBeCalculatedBySlave(Guid slaveId, Job curJob) {
+      var assignedResourceIds = dao.GetAssignedResources(curJob.Id).Select(x => x.Id);
+      var slaveResourceIds = dao.GetParentResources(slaveId).Select(x => x.Id);
+      return assignedResourceIds.Any(x => slaveResourceIds.Contains(x));
+    }
+
+    private bool SlaveIsAllowedToCalculate(Guid slaveId) {
+      // the slave may only calculate if there is no downtime right now. this needs to be checked for every parent resource also
+      return dao.GetParentResources(slaveId).All(r => dao.GetDowntimes(x => x.ResourceId == r.Id && (DateTime.Now >= x.StartDate) && (DateTime.Now <= x.EndDate)).Count() == 0);
+    }
+  }
+}
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/Manager/LifecycleManager.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/Manager/LifecycleManager.cs	(revision 6463)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/Manager/LifecycleManager.cs	(revision 6463)
@@ -0,0 +1,118 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Services.Hive.Common;
+using HeuristicLab.Services.Hive.Common.DataTransfer;
+
+namespace HeuristicLab.Services.Hive {
+  /// <summary>
+  /// This class offers methods for cleaning up offline slaves and jobs
+  /// </summary>
+  public class LifecycleManager : ILifecycleManager {
+    private DataAccess.IHiveDao dao {
+      get { return ServiceLocator.Instance.HiveDao; }
+    }
+    private IAuthorizationManager auth {
+      get { return ServiceLocator.Instance.AuthorizationManager; }
+    }
+    private ILogger log {
+      get { return LogFactory.GetLogger(this.GetType().Namespace); }
+    }
+
+    public void Cleanup() {
+      log.Log("LifecycleManager.Cleanup()");
+      SetTimeoutSlavesOffline();
+      SetTimeoutJobsWaiting();
+      FinishParentJobs();
+      UpdateStatistics();
+    }
+
+    private void UpdateStatistics() {
+      var slaves = dao.GetSlaves(x => x.SlaveState == SlaveState.Calculating || x.SlaveState == SlaveState.Idle);
+
+      var stats = new Statistics();
+      stats.TimeStamp = DateTime.Now;
+      var slaveStats = new List<SlaveStatistics>();
+      foreach (var slave in slaves) {
+        slaveStats.Add(new SlaveStatistics() {
+          SlaveId = slave.Id,
+          Cores = slave.Cores.HasValue ? slave.Cores.Value : 0,
+          FreeCores = slave.FreeCores.HasValue ? slave.FreeCores.Value : 0,
+          Memory = slave.Memory.HasValue ? slave.Memory.Value : 0,
+          FreeMemory = slave.FreeMemory.HasValue ? slave.FreeMemory.Value : 0,
+          CpuUtilization = slave.CpuUtilization
+        });
+      }
+      stats.SlaveStatistics = slaveStats;
+      stats.UserStatistics = dao.GetUserStatistics();
+      dao.AddStatistics(stats);
+    }
+
+    /// <summary>
+    /// Searches for slaves which are timed out, puts them and their jobs offline
+    /// </summary>
+    private void SetTimeoutSlavesOffline() {
+      var slaves = dao.GetSlaves(x => x.SlaveState != SlaveState.Offline);
+      foreach (Slave slave in slaves) {
+        if (!slave.LastHeartbeat.HasValue || (DateTime.Now - slave.LastHeartbeat.Value) > Settings.Default.SlaveHeartbeatTimeout) {
+          slave.SlaveState = SlaveState.Offline;
+          SetJobsWaiting(slave.Id);
+          dao.UpdateSlave(slave);
+        }
+      }
+    }
+
+    /// <summary>
+    /// Looks for parent jobs which have FinishWhenChildJobsFinished and set their state to finished
+    /// </summary>
+    private void FinishParentJobs() {
+      var parentJobsToFinish = dao.GetParentJobs(dao.GetResources(x => true).Select(x => x.Id), 0, true);
+      foreach (var job in parentJobsToFinish) {
+        dao.UpdateJobState(job.Id, JobState.Finished, null, null, string.Empty);
+      }
+    }
+
+    private void SetJobsWaiting(Guid slaveId) {
+      var jobs = dao.GetJobs(x => x.State == JobState.Calculating).Where(x => x.StateLog.Last().SlaveId == slaveId);
+      foreach (var j in jobs) {
+        Job job = dao.UpdateJobState(j.Id, JobState.Waiting, slaveId, null, "Slave timed out.");
+        job.Command = null;
+        dao.UpdateJob(job);
+      }
+    }
+
+    /// <summary>
+    /// Looks for jobs which have not sent heartbeats for some time and reschedules them for calculation
+    /// </summary>
+    private void SetTimeoutJobsWaiting() {
+      var jobs = dao.GetJobs(x => (x.State == JobState.Calculating && (DateTime.Now - x.LastHeartbeat) > Settings.Default.CalculatingJobHeartbeatTimeout)
+                               || (x.State == JobState.Transferring && (DateTime.Now - x.LastHeartbeat) > Settings.Default.TransferringJobHeartbeatTimeout));
+      foreach (var j in jobs) {
+        Job job = dao.UpdateJobState(j.Id, JobState.Waiting, null, null, "Slave timed out.");
+        job.Command = null;
+        dao.UpdateJob(job);
+      }
+    }
+  }
+}
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/Manager/UserManager.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/Manager/UserManager.cs	(revision 6463)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/Manager/UserManager.cs	(revision 6463)
@@ -0,0 +1,22 @@
+﻿using System;
+using System.Web.Security;
+
+namespace HeuristicLab.Services.Hive {
+  public class UserManager : IUserManager {
+    public MembershipUser CurrentUser {
+      get { return Membership.GetUser(); }
+    }
+
+    public Guid CurrentUserId {
+      get { return (Guid)CurrentUser.ProviderUserKey; }
+    }
+
+    public MembershipUser GetUserByName(string username) {
+      return Membership.GetUser(username);
+    }
+
+    public MembershipUser GetUserById(Guid userId) {
+      return Membership.GetUser(userId);
+    }
+  }
+}
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/ServiceLocator.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/ServiceLocator.cs	(revision 6458)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/ServiceLocator.cs	(revision 6463)
@@ -74,4 +74,12 @@
     }
 
+    private IUserManager userManager;
+    public IUserManager UserManager {
+      get {
+        if (userManager == null) userManager = new UserManager();
+        return userManager;
+      }
+    }
+
     private HeartbeatManager heartbeatManager;
     public HeartbeatManager HeartbeatManager {
